# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from .. import utilities, tables

class OrganizationalUnit(pulumi.CustomResource):
    accounts: pulumi.Output[list]
    """
    List of child accounts for this Organizational Unit. Does not return account information for child Organizational Units. All elements have these attributes:
    """
    arn: pulumi.Output[str]
    """
    ARN of the organizational unit
    """
    name: pulumi.Output[str]
    """
    The name for the organizational unit
    """
    parent_id: pulumi.Output[str]
    """
    ID of the parent organizational unit, which may be the root
    """
    def __init__(__self__, resource_name, opts=None, name=None, parent_id=None, __name__=None, __opts__=None):
        """
        Provides a resource to create an organizational unit.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] name: The name for the organizational unit
        :param pulumi.Input[str] parent_id: ID of the parent organizational unit, which may be the root
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if not resource_name:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(resource_name, str):
            raise TypeError('Expected resource name to be a string')
        if opts and not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['name'] = name

        if parent_id is None:
            raise TypeError("Missing required property 'parent_id'")
        __props__['parent_id'] = parent_id

        __props__['accounts'] = None
        __props__['arn'] = None

        super(OrganizationalUnit, __self__).__init__(
            'aws:organizations/organizationalUnit:OrganizationalUnit',
            resource_name,
            __props__,
            opts)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

